import java.util.Scanner;

public class fran_middle_binsearchSegmentTree {

	static SegmentTree st;
	static int[] a;

	public static void main(String[] args) {
		Scanner reader = new Scanner(System.in);
		int n = reader.nextInt();
		int q = reader.nextInt();
		a = new int[n];
		for(int i = 0; i < n; i++) {
			a[i] = reader.nextInt();
		}
		st = new SegmentTree(a);
		for(int i = 0; i < q; i++) {
			int j = reader.nextInt();
			int x = reader.nextInt();
			st.set(j, x);
			int ans = middle();
			System.out.println(ans);
		}
		reader.close();
	}

	static int middle() {
		int lo = 0;
		int hi = a.length - 1;
		while(lo < hi) {
			int mid = (lo + hi) >> 1;
			if(f(mid) <= f(mid + 1)) {
				hi = mid;
			} else{ 
				lo = mid + 1;
			}
		}
		return lo;
	}
	
	static long f(int i) {
		long left = st.sum(0, i - 1);
		long right = st.sum(i + 1, a.length - 1);
		if(a[i] % 2 == 1) {
			if(left <= right) left += 1;
			else right += 1; 
		}
		return Math.abs(left - right);
	}
	
	static class SegmentTree {
		
		long[] sum;
		int[] a;
		
		public SegmentTree(int[] a) {
			this.a = a;
			int lg = (int)(Math.log(a.length) / Math.log(2) + 1);
			sum = new long[a.length * lg];
			build(a, 0, a.length - 1, 0);
		}
		
		private void build(int[] a, int l, int r, int n) {
			if(l == r) {
				sum[n] = a[l];
			} else {
				int m = (l + r) / 2;
				build(a, l, m, 2 * n + 1);
				build(a, m + 1, r, 2 * n + 2);
				sum[n] = sum[2 * n  + 1] + sum[2 * n + 2];
			}
		}
		
		public long sum(int i, int j) {
			if(i > j) return 0;
			return sum(i, j, 0, a.length - 1, 0);
		}
		
		private long sum(int i, int j, int l, int r, int n) {
			if(i > r || j < l) return 0;
			if(i <= l && r <= j) return sum[n];
			int m = (l + r) / 2;
			long ret = sum(i, j, l, m, 2 * n + 1);
			ret += sum(i, j, m + 1, r, 2 * n + 2);
			return ret;
		}
		
		public void set(int i, int v) {
			set(i, v, 0, a.length - 1, 0);
		}
		
		private void set(int i, int v, int l, int r, int n) {
			if(i < l || i > r) return;
			if(l == r) {
				sum[n] += v - a[l];
				a[l] = v;
			} else {
				int m = (l + r) / 2;
				set(i, v, l, m, 2 * n + 1);
				set(i, v, m + 1, r, 2 * n + 2);
				sum[n] = sum[2 * n  + 1] + sum[2 * n + 2];
			}
		}
		
	}


}
